## nom.tam.fits
Class BasicHDU

    java.lang.Object
      nom.tam.fits.BasicHDU

Direct Known Subclasses:
  ExtensionHDU, FauxHDU, PrimaryHDU, RandomGroupsHDU

public abstract class BasicHDU
extends Object

This abstract class is the parent of all HDU types. It provides basic functionality for an HDU.

Field Summary
`static int` `BITPIX_BYTE`
`static int` `BITPIX_DOUBLE`
`static int` `BITPIX_FLOAT`
`static int` `BITPIX_INT`
`static int` `BITPIX_LONG`
`static int` `BITPIX_SHORT`
`(package private) Data` `myData` The associated data unit.
`(package private) Header` `myHeader` The associated header.

Constructor Summary
`BasicHDU(Header header)` Create an HDU with the specified Header and an empty Data section

Method Summary
`(package private) boolean` `checkField(String name)` Check if a field is present and if so print it out.
`String` `getAuthor()` Return the name of the person who compiled the information in the data associated with this header.
`int[]` `getAxes()`
`int` `getBitPix()`
`int` `getBlankValue()`
`double` `getBScale()`
`String` `getBUnit()`
`double` `getBZero()`
`Date` `getCreationDate()` Get the FITS file creation date as a `Date` object.
`Data` `getData()` Get the associated Data object
`double` `getEpoch()` Deprecated. Replaced by getEquinox
`double` `getEquinox()` Get the equinox in years for the celestial coordinate system in which positions given in either the header or data are expressed.
`int` `getGroupCount()`
`Header` `getHeader()` Get the associated header
`String` `getInstrument()` Get the name of the instrument which was used to acquire the data in this FITS file.
`double` `getMaximumValue()` Return the minimum valid value in the array.
`double` `getMinimumValue()` Return the minimum valid value in the array.
`String` `getObject()` Get the name of the observed object in this FITS file.
`Date` `getObservationDate()` Get the FITS file observation date as a `Date` object.
`String` `getObserver()` Get the name of the person who acquired the data in this FITS file.
`String` `getOrigin()` Get the name of the organization which created this FITS file.
`int` `getParameterCount()`
`String` `getReference()` Return the citation of a reference where the data associated with this header are published.
`int` `getSize()` Get the total size in bytes of the HDU.
`String` `getTelescope()` Get the name of the telescope which was used to acquire the data in this FITS file.
`String` `getTrimmedString(String keyword)` Get the String value associated with `keyword`.
`abstract void` `info()` Print out some information about this HDU.
`static boolean` `isHeader(Header header)` Check that this is a valid header for the HDU.
`(package private) abstract Data` `manufactureData()` Create a Data object to correspond to the header description.
`void` `readData(BufferedDataInputStream stream)` Read in the Data object for this HDU.
`void` `skipData(BufferedDataInputStream stream)` Skip the Data object for this HDU.
`static void` `skipData(BufferedDataInputStream stream, Header hdr)` Skip the Data object immediately after the given Header object on the given stream object.
`void` `write(BufferedDataOutputStream stream)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### BITPIX_BYTE

    public static final int BITPIX_BYTE

See Also:
  Constant Field Values

### BITPIX_SHORT

    public static final int BITPIX_SHORT

See Also:
  Constant Field Values

### BITPIX_INT

    public static final int BITPIX_INT

See Also:
  Constant Field Values

### BITPIX_LONG

    public static final int BITPIX_LONG

See Also:
  Constant Field Values

### BITPIX_FLOAT

    public static final int BITPIX_FLOAT

See Also:
  Constant Field Values

### BITPIX_DOUBLE

    public static final int BITPIX_DOUBLE

See Also:
  Constant Field Values

### myHeader

    Header myHeader

  The associated header.

### myData

    Data myData

  The associated data unit.

Constructor Detail

### BasicHDU

    public BasicHDU(Header header)

  Create an HDU with the specified Header and an empty Data section

Parameters:
  `header` - the Header

Method Detail

### manufactureData

    abstract Data manufactureData()
                           throws FitsException

  Create a Data object to correspond to the header description.

  Returns:
    An unfilled Data object which can be used to read in the data for this HDU.
  Throws:
    `FitsException` - if the Data object could not be created from this HDU's Header

### skipData

    public static void skipData(BufferedDataInputStream stream,
                                Header hdr)
                         throws IOException

  Skip the Data object immediately after the given Header object on the given stream object.

  Parameters:
    `stream` - the stream which contains the data.
  Throws:
    `IOException` - if the Data object could not be skipped.

### skipData

    public void skipData(BufferedDataInputStream stream)
                  throws IOException

  Skip the Data object for this HDU.

  Parameters:
    `stream` - the stream which contains the data.
  Throws:
    `IOException` - if the Data object could not be skipped.

### readData

    public void readData(BufferedDataInputStream stream)
                  throws FitsException

  Read in the Data object for this HDU.

  Parameters:
    `stream` - the stream from which the data is read.
  Throws:
    `FitsException` - if the Data object could not be created from this HDU's Header

### getHeader

    public Header getHeader()

  Get the associated header

### getData

    public Data getData()

  Get the associated Data object

### getSize

    public int getSize()

  Get the total size in bytes of the HDU.

  Returns:
    The size in bytes.

### isHeader

    public static boolean isHeader(Header header)

  Check that this is a valid header for the HDU.

  Parameters:
    `header` - to validate.
  Returns:
    `true` if this is a valid header.

### info

    public abstract void info()

  Print out some information about this HDU.

### checkField

    boolean checkField(String name)

  Check if a field is present and if so print it out.

### write

    public void write(BufferedDataOutputStream stream)
               throws FitsException

  Throws:
    `FitsException`

### getTrimmedString

    public String getTrimmedString(String keyword)

  Get the String value associated with `keyword`.

  Parameters:
    `keyword` - the FITS keyword
  Returns:
    either `null` or a String with leading/trailing blanks stripped.

### getBitPix

    public int getBitPix()
                  throws FitsException

  Throws:
    `FitsException`

### getAxes

    public int[] getAxes()
                  throws FitsException

  Throws:
    `FitsException`

### getParameterCount

    public int getParameterCount()

### getGroupCount

    public int getGroupCount()

### getBScale

    public double getBScale()

### getBZero

    public double getBZero()

### getBUnit

    public String getBUnit()

### getBlankValue

    public int getBlankValue()
                      throws FitsException

  Throws:
    `FitsException`

### getCreationDate

    public Date getCreationDate()

  Get the FITS file creation date as a `Date` object.

  Returns:
    either `null` or a Date object

### getObservationDate

    public Date getObservationDate()

  Get the FITS file observation date as a `Date` object.

  Returns:
    either `null` or a Date object

### getOrigin

    public String getOrigin()

  Get the name of the organization which created this FITS file.

  Returns:
    either `null` or a String object

### getTelescope

    public String getTelescope()

  Get the name of the telescope which was used to acquire the data in this FITS file.

  Returns:
    either `null` or a String object

### getInstrument

    public String getInstrument()

  Get the name of the instrument which was used to acquire the data in this FITS file.

  Returns:
    either `null` or a String object

### getObserver

    public String getObserver()

  Get the name of the person who acquired the data in this FITS file.

  Returns:
    either `null` or a String object

### getObject

    public String getObject()

  Get the name of the observed object in this FITS file.

  Returns:
    either `null` or a String object

### getEquinox

    public double getEquinox()

  Get the equinox in years for the celestial coordinate system in which positions given in either the header or data are expressed.

  Returns:
    either `null` or a String object

### getEpoch

    public double getEpoch()

  Deprecated. Replaced by getEquinox

  Get the equinox in years for the celestial coordinate system in which positions given in either the header or data are expressed.

  Returns:
    either `null` or a String object
  See Also:
    `getEquinox()`

### getAuthor

    public String getAuthor()

  Return the name of the person who compiled the information in the data associated with this header.

  Returns:
    either `null` or a String object

### getReference

    public String getReference()

  Return the citation of a reference where the data associated with this header are published.

  Returns:
    either `null` or a String object

### getMaximumValue

    public double getMaximumValue()

  Return the minimum valid value in the array.

  Returns:
    minimum value.

### getMinimumValue

    public double getMinimumValue()

  Return the minimum valid value in the array.

  Returns:
    minimum value.